<?php

// No direct access to this file

defined('_JEXEC') or die('Restricted access');

 

// import Joomla modelitem library

jimport('joomla.application.component.modelitem');

 

/**

 * HelloWorld Model

 */
 

class SyncModelSync extends JModelItem

{

	/**

	 * @var string msg

	 */

	protected $msg;
 

	/**

	 * Get the message

	 * @return string The message to be displayed to the user

	 */



	public function getTable($type = 'Document', $prefix = 'SyncTable', $config = array())
	{
		return JTable::getInstance($type, $prefix, $config);
	}
	

	public function getMsg() 
	{

		if (!isset($this->msg)) 
		{

			//$this->msg = 'Sync in the model';

			$id = JRequest::getInt('id');

			switch ($id) 
			{
				case 2:

					$this->msg = 'Radio 2003-2004';

					break;

				default:

				case 1:

					$this->msg = 'Radio 2004-2005';

					break;

			}	
			
			
			////////////////////////////////////////////////////////////////
			// get the list of the files
			
			$this->msg = "";
			$dir = '/edocman/databook/radio/2004-2005';			
			
			if($dh = opendir($dir)) {
	
				$files = Array();
				$inner_files = Array();
		
				while($file = readdir($dh)) {
					if($file != "." && $file != ".." && $file[0] != '.') {
						if(is_dir($dir . "/" . $file)) {
							$inner_files = ListFiles($dir . "/" . $file);
							if(is_array($inner_files)) $files = array_merge($files, $inner_files);
						} else {
							array_push($files, $dir . "/" . $file);
						}
					}
				}
		
				closedir($dh);
				//return $files;
				
				$this->msg .= "<strong>LIST of files in: databook/radio/2004-2005 </strong><br />";
				
				foreach ($files as $key=>$file){
					//echo substr($file, 44) ."<br />";
					$this->msg .= substr($file, 44) ."<br />";
				}				
			}   //if($dh = opendir($dir)) {
			
			
			
			
			
			////////////////////////////////////////////////////////////////
			//insert files into the DB
			$db =& JFactory::getDBO();
 
			//$query = "SELECT original_filename FROM #__edocman_documents WHERE id =11;";
			
			//$result = $db->query();
			//echo "<br />----" . $count ."----<br />";
			
			$this->msg .= "<br /><br />---------------------------<br />";
			
			
			foreach ($files as $key=>$file){
			   // echo substr($file, 44) ."<br />";
			   
				$query = 'SELECT count(id) FROM #__edocman_documents WHERE filename = "'. substr($file, 44) .'";';
				$db->setQuery($query);
				$count = $db->loadResult();
					
				if ($count > 0) {
					 $this->msg .= substr($file, 44) ." -- exists <br />";
				}
				else { 
					$this->msg .= substr($file, 44) ."-- not exists <br />"; 
					
					//insert into __assets table
					
					$data_assets = new stdClass();
					$data_assets->id = null;		
					$data_assets->parent_id = '56';		//radio 2004-2005 edocman category  //assets->id of the category of the document 
					$data_assets->lft = '';				////???????
					$data_assets->rgt = '';				////???????
					$data_assets->level = '5';			////???????
					$data_assets->name = 'com_edocman.document.5';
					$data_assets->title = substr($file, 69);
					$data_assets->rules = '{"core.delete":[],"core.edit":[],"core.edit.state":[],"edocman.download":[]}';	
					
					
					//$db_assets = JFactory::getDBO();
					//$db_assets->insertObject( '#__assets', $data_assets, id );
					
					//$data_assets_id = $db_assets->insertid();
					
					//$edocman_documents_id = $db_edocman_documents->insertid();
					
					//insert into __edocman_documents table
					$data_documents = new stdClass();
					$data_documents->id = null;		
					$data_documents->title = substr($file, 68);
					$data_documents->alias = substr($file, 68);
					$data_documents->filename = substr($file, 44);
					$data_documents->original_filename = substr($file, 68);				
					$data_documents->document_url = '';
					$data_documents->access = '1';
					$data_documents->short_description = substr($file, 68);
					$data_documents->description = substr($file, 68);
					$data_documents->metakey = '';
					$data_documents->metadesc = '';
					//$data->created_time = JFactory::getDate();
					$data_documents->created_time = date("Y-m-d H:i:s");
					$data_documents->asset_id = $data_assets_id;    	//get it from the assets table
					$data_documents->published = '1';		
					
					$db_edocman_documents = JFactory::getDBO();
					$db_edocman_documents->insertObject( '#__edocman_documents', $data_documents, id );
					 
					//$db->query();
					$edocman_documents_id = $db_edocman_documents->insertid();
					
					$this->msg .=  "<br />----------$edocman_documents_id----$data->created_time------<br />";
					
					
					//insert into __edocman_document_category with the ID from __edocman_documents 
					$data_document_category = new stdClass();
					$data_document_category->id = null;		
					$data_document_category->document_id = $edocman_documents_id;		//id of the inserted document
					$data_document_category->category_id = '4';							//hardcoded the category of the folder /edocman/databook/radio/2004-2005
					
					$db_edocman_document_category = JFactory::getDBO();
					$db_edocman_document_category->insertObject( '#__edocman_document_category', $data_document_category, id );
					
					 
				}
			   
			}  

			
			
			   
			

		}  //if !isset $this->msg

		

		return $this->msg;

	}

	
}